/*
 * This file is part of the Nepomuk KDE project.
 *
 * This library is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * See the file "COPYING" for the exact licensing terms.
 */

/*
 * This file has been generated by the Nepomuk Resource class generator.
 * DO NOT EDIT THIS FILE.
 * ANY CHANGES WILL BE LOST.
 */

#include <soprano/soprano.h>

#include "attendee.h"

#include "attendeerole.h"
#include "calendarusertype.h"
#include "unionofalarmeventfreebusyjournaltodo.h"
#include "participationstatus.h"
#include "contact.h"

#include <QtCore/QDateTime>
#include <QtCore/QDate>
#include <QtCore/QTime>

NepomukFast::Attendee::Attendee( const QUrl &uri, const QUrl &graphUri )
  : AttendeeOrOrganizer( uri, graphUri, QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/04/02/ncal#Attendee", QUrl::StrictMode) )
{
}

NepomukFast::Attendee::Attendee( const QUrl& uri, const QUrl& graphUri, const QUrl& type )
  : AttendeeOrOrganizer( uri, graphUri, type )
{
}

void NepomukFast::Attendee::setDelegatedFroms( const QList<NepomukFast::Contact>& value )
{
    for( QList<Contact>::const_iterator it = value.constBegin();
         it != value.constEnd(); ++it ) {
       addProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/04/02/ncal#delegatedFrom"), (*it).uri() );
    }
}

void NepomukFast::Attendee::addDelegatedFrom( const NepomukFast::Contact& value )
{
    addProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/04/02/ncal#delegatedFrom"), value.uri() );
}

QUrl NepomukFast::Attendee::delegatedFromUri()
{
    return QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/04/02/ncal#delegatedFrom");
}

void NepomukFast::Attendee::setCutypes( const QList<NepomukFast::CalendarUserType>& value )
{
    for( QList<CalendarUserType>::const_iterator it = value.constBegin();
         it != value.constEnd(); ++it ) {
       addProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/04/02/ncal#cutype"), (*it).uri() );
    }
}

void NepomukFast::Attendee::addCutype( const NepomukFast::CalendarUserType& value )
{
    addProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/04/02/ncal#cutype"), value.uri() );
}

QUrl NepomukFast::Attendee::cutypeUri()
{
    return QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/04/02/ncal#cutype");
}

void NepomukFast::Attendee::setMembers( const QList<NepomukFast::Contact>& value )
{
    for( QList<Contact>::const_iterator it = value.constBegin();
         it != value.constEnd(); ++it ) {
       addProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/04/02/ncal#member"), (*it).uri() );
    }
}

void NepomukFast::Attendee::addMember( const NepomukFast::Contact& value )
{
    addProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/04/02/ncal#member"), value.uri() );
}

QUrl NepomukFast::Attendee::memberUri()
{
    return QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/04/02/ncal#member");
}

void NepomukFast::Attendee::setRsvps( const QList<bool>& value )
{
    for( QList<bool>::const_iterator it = value.constBegin();
         it != value.constEnd(); ++it ) {
       addProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/04/02/ncal#rsvp"), Soprano::LiteralValue( *it ) );
    }
}

void NepomukFast::Attendee::addRsvp( const bool& value )
{
    addProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/04/02/ncal#rsvp"), Soprano::LiteralValue( value ) );
}

QUrl NepomukFast::Attendee::rsvpUri()
{
    return QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/04/02/ncal#rsvp");
}

void NepomukFast::Attendee::setPartstats( const QList<NepomukFast::ParticipationStatus>& value )
{
    for( QList<ParticipationStatus>::const_iterator it = value.constBegin();
         it != value.constEnd(); ++it ) {
       addProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/04/02/ncal#partstat"), (*it).uri() );
    }
}

void NepomukFast::Attendee::addPartstat( const NepomukFast::ParticipationStatus& value )
{
    addProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/04/02/ncal#partstat"), value.uri() );
}

QUrl NepomukFast::Attendee::partstatUri()
{
    return QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/04/02/ncal#partstat");
}

void NepomukFast::Attendee::setDelegatedTos( const QList<NepomukFast::Contact>& value )
{
    for( QList<Contact>::const_iterator it = value.constBegin();
         it != value.constEnd(); ++it ) {
       addProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/04/02/ncal#delegatedTo"), (*it).uri() );
    }
}

void NepomukFast::Attendee::addDelegatedTo( const NepomukFast::Contact& value )
{
    addProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/04/02/ncal#delegatedTo"), value.uri() );
}

QUrl NepomukFast::Attendee::delegatedToUri()
{
    return QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/04/02/ncal#delegatedTo");
}

void NepomukFast::Attendee::setRoles( const QList<NepomukFast::AttendeeRole>& value )
{
    for( QList<AttendeeRole>::const_iterator it = value.constBegin();
         it != value.constEnd(); ++it ) {
       addProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/04/02/ncal#role"), (*it).uri() );
    }
}

void NepomukFast::Attendee::addRole( const NepomukFast::AttendeeRole& value )
{
    addProperty( QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/04/02/ncal#role"), value.uri() );
}

QUrl NepomukFast::Attendee::roleUri()
{
    return QUrl::fromEncoded("http://www.semanticdesktop.org/ontologies/2007/04/02/ncal#role");
}


