/*
 * This file is part of the Nepomuk KDE project.
 *
 * This library is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * See the file "COPYING" for the exact licensing terms.
 */

/*
 * This file has been generated by the Nepomuk Resource class generator.
 * DO NOT EDIT THIS FILE.
 * ANY CHANGES WILL BE LOST.
 */

#ifndef _ATTENDEEORORGANIZER_H_
#define _ATTENDEEORORGANIZER_H_

class QDateTime;
class QDate;
class QTime;

namespace NepomukFast {
    class Contact;
    class Resource;

}

#include "resource.h"

namespace NepomukFast {

    /**
     * A common superclass for ncal:Attendee and ncal:Organizer. 
     */
    class AttendeeOrOrganizer : public NepomukFast::Resource
    {
    public:
        /**
         * Create a new empty and invalid AttendeeOrOrganizer instance
         */
        AttendeeOrOrganizer( const QUrl &uri = QUrl(), const QUrl &graphUri = QUrl() );

        /**
         * Set property 'involvedContact'. A contact of the Attendee 
         * or the organizer involved in an event or other calendar entity. 
         * This property has been introduced to express the actual value 
         * of the ATTENDEE and ORGANIZER properties. The contact will 
         * also represent the CN parameter of those properties. See documentation 
         * of ncal:attendee or ncal:organizer for more details. 
         */
        void setInvolvedContacts( const QList<Contact>& value );

        /**
         * Add a value to property 'involvedContact'. A contact of the 
         * Attendee or the organizer involved in an event or other calendar 
         * entity. This property has been introduced to express the actual 
         * value of the ATTENDEE and ORGANIZER properties. The contact 
         * will also represent the CN parameter of those properties. See 
         * documentation of ncal:attendee or ncal:organizer for more 
         * details. 
         */
        void addInvolvedContact( const Contact& value );

        /**
         * \return The URI of the property 'involvedContact'. 
         */
        static QUrl involvedContactUri();

        /**
         * Set property 'sentBy'. To specify the calendar user that is 
         * acting on behalf of the calendar user specified by the property. 
         * Inspired by RFC 2445 sec. 4.2.18. The original data type of this 
         * property was a mailto: URI. This has been changed to nco:Contact 
         * to promote integration between NCO and NCAL. 
         */
        void setSentBys( const QList<Contact>& value );

        /**
         * Add a value to property 'sentBy'. To specify the calendar user 
         * that is acting on behalf of the calendar user specified by the 
         * property. Inspired by RFC 2445 sec. 4.2.18. The original data 
         * type of this property was a mailto: URI. This has been changed 
         * to nco:Contact to promote integration between NCO and NCAL. 
         */
        void addSentBy( const Contact& value );

        /**
         * \return The URI of the property 'sentBy'. 
         */
        static QUrl sentByUri();

        /**
         * Set property 'dir'. Specifies a reference to a directory entry 
         * associated with the calendar user specified by the property. 
         * Inspired by RFC 2445 sec. 4.2.6. Originally the data type of 
         * the value of this parameter was URI (Usually an LDAP URI). This 
         * has been expressed as rdfs:resource. 
         */
        void setDirs( const QList<Resource>& value );

        /**
         * Add a value to property 'dir'. Specifies a reference to a directory 
         * entry associated with the calendar user specified by the property. 
         * Inspired by RFC 2445 sec. 4.2.6. Originally the data type of 
         * the value of this parameter was URI (Usually an LDAP URI). This 
         * has been expressed as rdfs:resource. 
         */
        void addDir( const Resource& value );

        /**
         * \return The URI of the property 'dir'. 
         */
        static QUrl dirUri();



    protected:
        AttendeeOrOrganizer( const QUrl& uri, const QUrl& graphUri, const QUrl& type );
    };
}

#endif
