/*
 * This file is part of the Nepomuk KDE project.
 *
 * This library is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * See the file "COPYING" for the exact licensing terms.
 */

/*
 * This file has been generated by the Nepomuk Resource class generator.
 * DO NOT EDIT THIS FILE.
 * ANY CHANGES WILL BE LOST.
 */

#ifndef _CONTACTLIST_H_
#define _CONTACTLIST_H_

class QDateTime;
class QDate;
class QTime;

namespace NepomukFast {
    class ContactListDataObject;

}

#include "informationelement.h"

namespace NepomukFast {

    /**
     * A contact list, this class represents an addressbook or a contact 
     * list of an IM application. Contacts inside a contact list can 
     * belong to contact groups. 
     */
    class ContactList : public InformationElement
    {
    public:
        /**
         * Create a new empty and invalid ContactList instance
         */
        ContactList( const QUrl &uri = QUrl(), const QUrl &graphUri = QUrl() );

        /**
         * Set property 'containsContact'. A property used to group contacts 
         * into contact groups. This property was NOT defined in the VCARD 
         * standard. See documentation for the 'ContactList' class for 
         * details 
         */
        void setContainsContacts( const QList<ContactListDataObject>& value );

        /**
         * Add a value to property 'containsContact'. A property used 
         * to group contacts into contact groups. This property was NOT 
         * defined in the VCARD standard. See documentation for the 'ContactList' 
         * class for details 
         */
        void addContainsContact( const ContactListDataObject& value );

        /**
         * \return The URI of the property 'containsContact'. 
         */
        static QUrl containsContactUri();



    protected:
        ContactList( const QUrl& uri, const QUrl& graphUri, const QUrl& type );
    };
}

#endif
