/*
 * This file is part of the Nepomuk KDE project.
 *
 * This library is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * See the file "COPYING" for the exact licensing terms.
 */

/*
 * This file has been generated by the Nepomuk Resource class generator.
 * DO NOT EDIT THIS FILE.
 * ANY CHANGES WILL BE LOST.
 */

#ifndef _JOURNAL_H_
#define _JOURNAL_H_

class QDateTime;
class QDate;
class QTime;

namespace NepomukFast {
    class UnionOfTimezoneObservanceEventFreebusyJournalTimezoneTodo;
    class InformationElement;
    class UnionOfEventJournalTodo;
    class UnionOfTimezoneObservanceEventJournalTimezoneTodo;
    class UnionOfAlarmEventFreebusyJournalTodo;
    class UnionOfEventFreebusyJournalTodo;
    class JournalStatus;
    class UnionOfAlarmEventJournalTodo;
    class UnionOfEventJournalTimezoneTodo;

}

#include "unionofeventjournaltodo.h"

namespace NepomukFast {

    /**
     * Provide a grouping of component properties that describe a 
     * journal entry. 
     */
    class Journal : public UnionOfEventJournalTodo
    {
    public:
        /**
         * Create a new empty and invalid Journal instance
         */
        Journal( const QUrl &uri = QUrl(), const QUrl &graphUri = QUrl() );

        /**
         * Set property 'journalStatus'. Defines the overall status 
         * or confirmation for a journal entry. Based on the STATUS property 
         * defined in RFC 2445 sec. 4.8.1.11. 
         */
        void setJournalStatuses( const QList<JournalStatus>& value );

        /**
         * Add a value to property 'journalStatus'. Defines the overall 
         * status or confirmation for a journal entry. Based on the STATUS 
         * property defined in RFC 2445 sec. 4.8.1.11. 
         */
        void addJournalStatus( const JournalStatus& value );

        /**
         * \return The URI of the property 'journalStatus'. 
         */
        static QUrl journalStatusUri();

        /**
         * Nepomuk does not support multiple inheritance. Thus, to access 
         * properties from all parent classes helper methods like this 
         * are introduced. The object returned represents the exact same 
         * resource. 
         */
        UnionOfTimezoneObservanceEventJournalTimezoneTodo toUnionOfTimezoneObservanceEventJournalTimezoneTodo() const;

        /**
         * Nepomuk does not support multiple inheritance. Thus, to access 
         * properties from all parent classes helper methods like this 
         * are introduced. The object returned represents the exact same 
         * resource. 
         */
        UnionOfAlarmEventFreebusyJournalTodo toUnionOfAlarmEventFreebusyJournalTodo() const;

        /**
         * Nepomuk does not support multiple inheritance. Thus, to access 
         * properties from all parent classes helper methods like this 
         * are introduced. The object returned represents the exact same 
         * resource. 
         */
        UnionOfEventJournalTimezoneTodo toUnionOfEventJournalTimezoneTodo() const;

        /**
         * Nepomuk does not support multiple inheritance. Thus, to access 
         * properties from all parent classes helper methods like this 
         * are introduced. The object returned represents the exact same 
         * resource. 
         */
        UnionOfTimezoneObservanceEventFreebusyJournalTimezoneTodo toUnionOfTimezoneObservanceEventFreebusyJournalTimezoneTodo() const;

        /**
         * Nepomuk does not support multiple inheritance. Thus, to access 
         * properties from all parent classes helper methods like this 
         * are introduced. The object returned represents the exact same 
         * resource. 
         */
        UnionOfAlarmEventJournalTodo toUnionOfAlarmEventJournalTodo() const;

        /**
         * Nepomuk does not support multiple inheritance. Thus, to access 
         * properties from all parent classes helper methods like this 
         * are introduced. The object returned represents the exact same 
         * resource. 
         */
        UnionOfEventFreebusyJournalTodo toUnionOfEventFreebusyJournalTodo() const;

        /**
         * Nepomuk does not support multiple inheritance. Thus, to access 
         * properties from all parent classes helper methods like this 
         * are introduced. The object returned represents the exact same 
         * resource. 
         */
        InformationElement toInformationElement() const;

        /**
         * Nepomuk does not support multiple inheritance. Thus, to access 
         * properties from all parent classes helper methods like this 
         * are introduced. The object returned represents the exact same 
         * resource. 
         */
        UnionOfEventJournalTodo toUnionOfEventJournalTodo() const;



    protected:
        Journal( const QUrl& uri, const QUrl& graphUri, const QUrl& type );
    };
}

#endif
