/*
 * This file is part of the Nepomuk KDE project.
 *
 * This library is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * See the file "COPYING" for the exact licensing terms.
 */

/*
 * This file has been generated by the Nepomuk Resource class generator.
 * DO NOT EDIT THIS FILE.
 * ANY CHANGES WILL BE LOST.
 */

#ifndef _RECURRENCERULE_H_
#define _RECURRENCERULE_H_

class QDateTime;
class QDate;
class QTime;

namespace NepomukFast {
    class UnionOfEventJournalTodo;
    class BydayRulePart;
    class UnionOfTimezoneObservanceEventJournalTimezoneTodo;
    class Weekday;
    class RecurrenceFrequency;

}

#include "resource.h"

namespace NepomukFast {


    class RecurrenceRule : public NepomukFast::Resource
    {
    public:
        /**
         * Create a new empty and invalid RecurrenceRule instance
         */
        RecurrenceRule( const QUrl &uri = QUrl(), const QUrl &graphUri = QUrl() );

        /**
         * Set property 'wkst'. The day that's counted as the start of the 
         * week. It is used to disambiguate the byweekno rule. Defined 
         * in RFC 2445 sec. 4.3.10 
         */
        void setWksts( const QList<Weekday>& value );

        /**
         * Add a value to property 'wkst'. The day that's counted as the 
         * start of the week. It is used to disambiguate the byweekno rule. 
         * Defined in RFC 2445 sec. 4.3.10 
         */
        void addWkst( const Weekday& value );

        /**
         * \return The URI of the property 'wkst'. 
         */
        static QUrl wkstUri();

        /**
         * Set property 'bymonthday'. Day of the month when the event should 
         * recur. Defined in RFC 2445 sec. 4.3.10 
         */
        void setBymonthdays( const QList<qint64>& value );

        /**
         * Add a value to property 'bymonthday'. Day of the month when the 
         * event should recur. Defined in RFC 2445 sec. 4.3.10 
         */
        void addBymonthday( const qint64& value );

        /**
         * \return The URI of the property 'bymonthday'. 
         */
        static QUrl bymonthdayUri();

        /**
         * Set property 'byyearday'. Day of the year the event should occur. 
         * Defined in RFC 2445 sec. 4.3.10 
         */
        void setByyeardays( const QList<qint64>& value );

        /**
         * Add a value to property 'byyearday'. Day of the year the event 
         * should occur. Defined in RFC 2445 sec. 4.3.10 
         */
        void addByyearday( const qint64& value );

        /**
         * \return The URI of the property 'byyearday'. 
         */
        static QUrl byyeardayUri();

        /**
         * Set property 'count'. How many times should an event be repeated. 
         * Defined in RFC 2445 sec. 4.3.10 
         */
        void setCounts( const QList<qint64>& value );

        /**
         * Add a value to property 'count'. How many times should an event 
         * be repeated. Defined in RFC 2445 sec. 4.3.10 
         */
        void addCount( const qint64& value );

        /**
         * \return The URI of the property 'count'. 
         */
        static QUrl countUri();

        /**
         * Set property 'bymonth'. Number of the month of the recurrence. 
         * Valid values are integers from 1 (January) to 12 (December). 
         * Defined in RFC 2445 sec. 4.3.10 
         */
        void setBymonths( const QList<qint64>& value );

        /**
         * Add a value to property 'bymonth'. Number of the month of the 
         * recurrence. Valid values are integers from 1 (January) to 12 
         * (December). Defined in RFC 2445 sec. 4.3.10 
         */
        void addBymonth( const qint64& value );

        /**
         * \return The URI of the property 'bymonth'. 
         */
        static QUrl bymonthUri();

        /**
         * Set property 'until'. The UNTIL rule part defines a date-time 
         * value which bounds the recurrence rule in an inclusive manner. 
         * If the value specified by UNTIL is synchronized with the specified 
         * recurrence, this date or date-time becomes the last instance 
         * of the recurrence. If specified as a date-time value, then it 
         * MUST be specified in an UTC time format. If not present, and the 
         * COUNT rule part is also not present, the RRULE is considered 
         * to repeat forever. 
         */
        void setUntils( const QList<QDateTime>& value );

        /**
         * Add a value to property 'until'. The UNTIL rule part defines 
         * a date-time value which bounds the recurrence rule in an inclusive 
         * manner. If the value specified by UNTIL is synchronized with 
         * the specified recurrence, this date or date-time becomes the 
         * last instance of the recurrence. If specified as a date-time 
         * value, then it MUST be specified in an UTC time format. If not 
         * present, and the COUNT rule part is also not present, the RRULE 
         * is considered to repeat forever. 
         */
        void addUntil( const QDateTime& value );

        /**
         * \return The URI of the property 'until'. 
         */
        static QUrl untilUri();

        /**
         * Set property 'bysecond'. Second of a recurrence. Defined in 
         * RFC 2445 sec. 4.3.10 
         */
        void setByseconds( const QList<qint64>& value );

        /**
         * Add a value to property 'bysecond'. Second of a recurrence. 
         * Defined in RFC 2445 sec. 4.3.10 
         */
        void addBysecond( const qint64& value );

        /**
         * \return The URI of the property 'bysecond'. 
         */
        static QUrl bysecondUri();

        /**
         * Set property 'interval'. The INTERVAL rule part contains a 
         * positive integer representing how often the recurrence rule 
         * repeats. The default value is "1", meaning every second for 
         * a SECONDLY rule, or every minute for a MINUTELY rule, every hour 
         * for an HOURLY rule, every day for a DAILY rule, every week for 
         * a WEEKLY rule, every month for a MONTHLY rule andevery year for 
         * a YEARLY rule. Defined in RFC 2445 sec. 4.3.10 
         */
        void setIntervals( const QList<qint64>& value );

        /**
         * Add a value to property 'interval'. The INTERVAL rule part contains 
         * a positive integer representing how often the recurrence rule 
         * repeats. The default value is "1", meaning every second for 
         * a SECONDLY rule, or every minute for a MINUTELY rule, every hour 
         * for an HOURLY rule, every day for a DAILY rule, every week for 
         * a WEEKLY rule, every month for a MONTHLY rule andevery year for 
         * a YEARLY rule. Defined in RFC 2445 sec. 4.3.10 
         */
        void addInterval( const qint64& value );

        /**
         * \return The URI of the property 'interval'. 
         */
        static QUrl intervalUri();

        /**
         * Set property 'byday'. Weekdays the recurrence should occur. 
         * Defined in RFC 2445 sec. 4.3.10 
         */
        void setBydays( const QList<BydayRulePart>& value );

        /**
         * Add a value to property 'byday'. Weekdays the recurrence should 
         * occur. Defined in RFC 2445 sec. 4.3.10 
         */
        void addByday( const BydayRulePart& value );

        /**
         * \return The URI of the property 'byday'. 
         */
        static QUrl bydayUri();

        /**
         * Set property 'byweekno'. The number of the week an event should 
         * recur. Defined in RFC 2445 sec. 4.3.10 
         */
        void setByweeknos( const QList<qint64>& value );

        /**
         * Add a value to property 'byweekno'. The number of the week an 
         * event should recur. Defined in RFC 2445 sec. 4.3.10 
         */
        void addByweekno( const qint64& value );

        /**
         * \return The URI of the property 'byweekno'. 
         */
        static QUrl byweeknoUri();

        /**
         * Set property 'bysetpos'. The BYSETPOS rule part specify values 
         * which correspond to the nth occurrence within the set of events 
         * specified by the rule. Valid values are 1 to 366 or -366 to -1. 
         * It MUST only be used in conjunction with another BYxxx rule part. 
         * For example "the last work day of the month" could be represented 
         * as: RRULE: FREQ=MONTHLY; BYDAY=MO, TU, WE, TH, FR; BYSETPOS=-1. 
         * Each BYSETPOS value can include a positive (+n) or negative 
         * (-n) integer. If present, this indicates the nth occurrence 
         * of the specific occurrence within the set of events specified 
         * by the rule. Defined in RFC 2445 sec. 4.3.10 
         */
        void setBysetposes( const QList<qint64>& value );

        /**
         * Add a value to property 'bysetpos'. The BYSETPOS rule part specify 
         * values which correspond to the nth occurrence within the set 
         * of events specified by the rule. Valid values are 1 to 366 or -366 
         * to -1. It MUST only be used in conjunction with another BYxxx 
         * rule part. For example "the last work day of the month" could 
         * be represented as: RRULE: FREQ=MONTHLY; BYDAY=MO, TU, WE, 
         * TH, FR; BYSETPOS=-1. Each BYSETPOS value can include a positive 
         * (+n) or negative (-n) integer. If present, this indicates the 
         * nth occurrence of the specific occurrence within the set of 
         * events specified by the rule. Defined in RFC 2445 sec. 4.3.10 
         */
        void addBysetpos( const qint64& value );

        /**
         * \return The URI of the property 'bysetpos'. 
         */
        static QUrl bysetposUri();

        /**
         * Set property 'byhour'. Hour of recurrence. Defined in RFC 2445 
         * sec. 4.3.10 
         */
        void setByhours( const QList<qint64>& value );

        /**
         * Add a value to property 'byhour'. Hour of recurrence. Defined 
         * in RFC 2445 sec. 4.3.10 
         */
        void addByhour( const qint64& value );

        /**
         * \return The URI of the property 'byhour'. 
         */
        static QUrl byhourUri();

        /**
         * Set property 'byminute'. Minute of recurrence. Defined in 
         * RFC 2445 sec. 4.3.10 
         */
        void setByminutes( const QList<qint64>& value );

        /**
         * Add a value to property 'byminute'. Minute of recurrence. Defined 
         * in RFC 2445 sec. 4.3.10 
         */
        void addByminute( const qint64& value );

        /**
         * \return The URI of the property 'byminute'. 
         */
        static QUrl byminuteUri();

        /**
         * Set property 'freq'. Frequency of a recurrence rule. Defined 
         * in RFC 2445 sec. 4.3.10 
         */
        void setFreqs( const QList<RecurrenceFrequency>& value );

        /**
         * Add a value to property 'freq'. Frequency of a recurrence rule. 
         * Defined in RFC 2445 sec. 4.3.10 
         */
        void addFreq( const RecurrenceFrequency& value );

        /**
         * \return The URI of the property 'freq'. 
         */
        static QUrl freqUri();



    protected:
        RecurrenceRule( const QUrl& uri, const QUrl& graphUri, const QUrl& type );
    };
}

#endif
