/*
 * This file is part of the Nepomuk KDE project.
 *
 * This library is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * See the file "COPYING" for the exact licensing terms.
 */

/*
 * This file has been generated by the Nepomuk Resource class generator.
 * DO NOT EDIT THIS FILE.
 * ANY CHANGES WILL BE LOST.
 */

#ifndef _REQUESTSTATUS_H_
#define _REQUESTSTATUS_H_

class QDateTime;
class QDate;
class QTime;

namespace NepomukFast {
    class UnionOfEventFreebusyJournalTodo;

}

#include "resource.h"

namespace NepomukFast {

    /**
     * Request Status. A class that was introduced to provide a structure 
     * for the value of ncal:requestStatus property. See documentation 
     * for ncal:requestStatus for details. 
     */
    class RequestStatus : public NepomukFast::Resource
    {
    public:
        /**
         * Create a new empty and invalid RequestStatus instance
         */
        RequestStatus( const QUrl &uri = QUrl(), const QUrl &graphUri = QUrl() );

        /**
         * Set property 'statusDescription'. Longer return status description. 
         * Inspired by the second part of the structured value of the REQUEST-STATUS 
         * property defined in RFC 2445 sec. 4.8.8.2 
         */
        void setStatusDescriptions( const QStringList& value );

        /**
         * Add a value to property 'statusDescription'. Longer return 
         * status description. Inspired by the second part of the structured 
         * value of the REQUEST-STATUS property defined in RFC 2445 sec. 
         * 4.8.8.2 
         */
        void addStatusDescription( const QString& value );

        /**
         * \return The URI of the property 'statusDescription'. 
         */
        static QUrl statusDescriptionUri();

        /**
         * Set property 'returnStatus'. Short return status. Inspired 
         * by the first element of the structured value of the REQUEST-STATUS 
         * property described in RFC 2445 sec. 4.8.8.2. The short return 
         * status is a PERIOD character (US-ASCII decimal 46) separated 
         * 3-tuple of integers. For example, "3.1.1". The successive 
         * levels of integers provide for a successive level of status 
         * code granularity. The following are initial classes for the 
         * return status code. Individual iCalendar object methods will 
         * define specific return status codes for these classes. In addition, 
         * other classes for the return status code may be defined using 
         * the registration process defined later in this memo. 1.xx - 
         * Preliminary success. This class of status of status code indicates 
         * that the request has request has been initially processed but 
         * that completion is pending. 2.xx -Successful. This class of 
         * status code indicates that the request was completed successfuly. 
         * However, the exact status code can indicate that a fallback 
         * has been taken. 3.xx - Client Error. This class of status code 
         * indicates that the request was not successful. The error is 
         * the result of either a syntax or a semantic error in the client 
         * formatted request. Request should not be retried until the 
         * condition in the request is corrected. 4.xx - Scheduling Error. 
         * This class of status code indicates that the request was not 
         * successful. Some sort of error occurred within the calendaring 
         * and scheduling service, not directly related to the request 
         * itself. 
         */
        void setReturnStatuses( const QStringList& value );

        /**
         * Add a value to property 'returnStatus'. Short return status. 
         * Inspired by the first element of the structured value of the 
         * REQUEST-STATUS property described in RFC 2445 sec. 4.8.8.2. 
         * The short return status is a PERIOD character (US-ASCII decimal 
         * 46) separated 3-tuple of integers. For example, "3.1.1". The 
         * successive levels of integers provide for a successive level 
         * of status code granularity. The following are initial classes 
         * for the return status code. Individual iCalendar object methods 
         * will define specific return status codes for these classes. 
         * In addition, other classes for the return status code may be 
         * defined using the registration process defined later in this 
         * memo. 1.xx - Preliminary success. This class of status of status 
         * code indicates that the request has request has been initially 
         * processed but that completion is pending. 2.xx -Successful. 
         * This class of status code indicates that the request was completed 
         * successfuly. However, the exact status code can indicate that 
         * a fallback has been taken. 3.xx - Client Error. This class of 
         * status code indicates that the request was not successful. 
         * The error is the result of either a syntax or a semantic error 
         * in the client formatted request. Request should not be retried 
         * until the condition in the request is corrected. 4.xx - Scheduling 
         * Error. This class of status code indicates that the request 
         * was not successful. Some sort of error occurred within the calendaring 
         * and scheduling service, not directly related to the request 
         * itself. 
         */
        void addReturnStatus( const QString& value );

        /**
         * \return The URI of the property 'returnStatus'. 
         */
        static QUrl returnStatusUri();

        /**
         * Set property 'requestStatusData'. Additional data associated 
         * with a request status. Inspired by the third part of the structured 
         * value for the REQUEST-STATUS property defined in RFC 2445 sec. 
         * 4.8.8.2 ("Textual exception data. For example, the offending 
         * property name and value or complete property line") 
         */
        void setRequestStatusDatas( const QStringList& value );

        /**
         * Add a value to property 'requestStatusData'. Additional data 
         * associated with a request status. Inspired by the third part 
         * of the structured value for the REQUEST-STATUS property defined 
         * in RFC 2445 sec. 4.8.8.2 ("Textual exception data. For example, 
         * the offending property name and value or complete property 
         * line") 
         */
        void addRequestStatusData( const QString& value );

        /**
         * \return The URI of the property 'requestStatusData'. 
         */
        static QUrl requestStatusDataUri();



    protected:
        RequestStatus( const QUrl& uri, const QUrl& graphUri, const QUrl& type );
    };
}

#endif
