/*
 * This file is part of the Nepomuk KDE project.
 *
 * This library is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * See the file "COPYING" for the exact licensing terms.
 */

/*
 * This file has been generated by the Nepomuk Resource class generator.
 * DO NOT EDIT THIS FILE.
 * ANY CHANGES WILL BE LOST.
 */

#ifndef _UNIONOFALARMEVENTJOURNALTODO_H_
#define _UNIONOFALARMEVENTJOURNALTODO_H_

class QDateTime;
class QDate;
class QTime;

namespace NepomukFast {
    class Attachment;
    class Resource;

}

#include "unionparentclass.h"

namespace NepomukFast {


    class UnionOfAlarmEventJournalTodo : public UnionParentClass
    {
    public:
        /**
         * Create a new empty and invalid UnionOfAlarmEventJournalTodo instance
         */
        UnionOfAlarmEventJournalTodo( const QUrl &uri = QUrl(), const QUrl &graphUri = QUrl() );

        /**
         * Set property 'summaryAltRep'. Alternate representation 
         * of the comment. Introduced to cover the ALTREP parameter of 
         * the SUMMARY property. See documentation of ncal:summary for 
         * details. 
         */
        void setSummaryAltReps( const QList<Resource>& value );

        /**
         * Add a value to property 'summaryAltRep'. Alternate representation 
         * of the comment. Introduced to cover the ALTREP parameter of 
         * the SUMMARY property. See documentation of ncal:summary for 
         * details. 
         */
        void addSummaryAltRep( const Resource& value );

        /**
         * \return The URI of the property 'summaryAltRep'. 
         */
        static QUrl summaryAltRepUri();

        /**
         * Set property 'summary'. Defines a short summary or subject 
         * for the calendar component. Inspired by RFC 2445 sec 4.8.1.12 
         * with the following reservations: the LANGUAGE parameter has 
         * been discarded. Please use xml:lang literals to express language. 
         * For the ALTREP parameter use the summaryAltRep property. 
         */
        void setSummarys( const QStringList& value );

        /**
         * Add a value to property 'summary'. Defines a short summary or 
         * subject for the calendar component. Inspired by RFC 2445 sec 
         * 4.8.1.12 with the following reservations: the LANGUAGE parameter 
         * has been discarded. Please use xml:lang literals to express 
         * language. For the ALTREP parameter use the summaryAltRep property. 
         */
        void addSummary( const QString& value );

        /**
         * \return The URI of the property 'summary'. 
         */
        static QUrl summaryUri();

        /**
         * Set property 'descriptionAltRep'. Alternate representation 
         * of the calendar entity description. Introduced to cover the 
         * ALTREP parameter of the DESCRIPTION property. See documentation 
         * of ncal:description for details. 
         */
        void setDescriptionAltReps( const QList<Resource>& value );

        /**
         * Add a value to property 'descriptionAltRep'. Alternate representation 
         * of the calendar entity description. Introduced to cover the 
         * ALTREP parameter of the DESCRIPTION property. See documentation 
         * of ncal:description for details. 
         */
        void addDescriptionAltRep( const Resource& value );

        /**
         * \return The URI of the property 'descriptionAltRep'. 
         */
        static QUrl descriptionAltRepUri();

        /**
         * Set property 'description'. A more complete description of 
         * the calendar component, than that provided by the ncal:summary 
         * property.Inspired by RFC 2445 sec. 4.8.1.5 with following 
         * reservations: the LANGUAGE parameter has been discarded. 
         * Please use xml:lang literals to express language. For the ALTREP 
         * parameter use the descriptionAltRep property. 
         */
        void setDescriptions( const QStringList& value );

        /**
         * Add a value to property 'description'. A more complete description 
         * of the calendar component, than that provided by the ncal:summary 
         * property.Inspired by RFC 2445 sec. 4.8.1.5 with following 
         * reservations: the LANGUAGE parameter has been discarded. 
         * Please use xml:lang literals to express language. For the ALTREP 
         * parameter use the descriptionAltRep property. 
         */
        void addDescription( const QString& value );

        /**
         * \return The URI of the property 'description'. 
         */
        static QUrl descriptionUri();

        /**
         * Set property 'attach'. The property provides the capability 
         * to associate a document object with a calendar component. Defined 
         * in the RFC 2445 sec. 4.8.1.1 
         */
        void setAttachs( const QList<Attachment>& value );

        /**
         * Add a value to property 'attach'. The property provides the 
         * capability to associate a document object with a calendar component. 
         * Defined in the RFC 2445 sec. 4.8.1.1 
         */
        void addAttach( const Attachment& value );

        /**
         * \return The URI of the property 'attach'. 
         */
        static QUrl attachUri();



    protected:
        UnionOfAlarmEventJournalTodo( const QUrl& uri, const QUrl& graphUri, const QUrl& type );
    };
}

#endif
