/*
 * This file is part of the Nepomuk KDE project.
 *
 * This library is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * See the file "COPYING" for the exact licensing terms.
 */

/*
 * This file has been generated by the Nepomuk Resource class generator.
 * DO NOT EDIT THIS FILE.
 * ANY CHANGES WILL BE LOST.
 */

#ifndef _VOICEPHONENUMBER_H_
#define _VOICEPHONENUMBER_H_

class QDateTime;
class QDate;
class QTime;

namespace NepomukFast {

}

#include "phonenumber.h"

namespace NepomukFast {

    /**
     * A telephone number with voice communication capabilities. 
     * Class inspired by the TYPE=voice parameter of the TEL property 
     * defined in RFC 2426 sec. 3.3.1 
     */
    class VoicePhoneNumber : public PhoneNumber
    {
    public:
        /**
         * Create a new empty and invalid VoicePhoneNumber instance
         */
        VoicePhoneNumber( const QUrl &uri = QUrl(), const QUrl &graphUri = QUrl() );

        /**
         * Set property 'voiceMail'. Indicates if the given number accepts 
         * voice mail. (e.g. there is an answering machine). Inspired 
         * by TYPE=msg parameter of the TEL property defined in RFC 2426 
         * sec. 3.3.1 
         */
        void setVoiceMails( const QList<bool>& value );

        /**
         * Add a value to property 'voiceMail'. Indicates if the given 
         * number accepts voice mail. (e.g. there is an answering machine). 
         * Inspired by TYPE=msg parameter of the TEL property defined 
         * in RFC 2426 sec. 3.3.1 
         */
        void addVoiceMail( const bool& value );

        /**
         * \return The URI of the property 'voiceMail'. 
         */
        static QUrl voiceMailUri();



    protected:
        VoicePhoneNumber( const QUrl& uri, const QUrl& graphUri, const QUrl& type );
    };
}

#endif
